
; boot efer operating system
; (c) 2008 kflavour

include 'kerndefs.inc'

CD		= 0		; boot from CD / DVD

FLOPPY		= 1		; boot from floppy ?

BOOTOFF		= 0x7c00	; phys addr where BIOS load boot sector
STACKTOP	= 0xffff

NLOADSECTS	= 11		; sectors to load (! must be less than 29Kb / 512 !)

STARTSECT	= 2


use16
org BOOTOFF
; INITIALISE SEG REGS
	xor	ax, ax

	mov	ds, ax
	mov	es, ax
	mov	ss, ax
	mov	sp, STACKTOP

; DISPLAY INF STR
	call	.drivinf
	mov	si, .info
	call	.puts16

if CD
	mov	si, BOOTOFF + 2048
	mov	di, KERNBASE
	mov	cx, 0x2000
	cld
	rep	movsb

else

; LOAD KERNEL
	mov	al, NLOADSECTS
	mov	cx, STARTSECT
	mov	dh, 0x00
 if FLOPPY
	mov	dl, 0x00
 end if
	mov	bx, KERNBASE
	mov	ah, 0x2
	int	0x13
	jc	.disk_err_read

end if

; CHECK SIGNATURE
	cmp	word [KERNBASE], 0xc085		; signat: test eax, eax
	jne	.sig_not_detect
	
; ALL DONE, PASS CONTROL TO KERNEL
	jmp	0:KERNBASE




;::::::::DRIVE:INFO::::::::::::::
.drivinf:
	push	dx

	mov	bx, .info
	cmp	dl, 0x80
	jae	.hdd
	mov	byte [bx + 1], 'f'
	add	dl, '0'
	mov	byte [bx + 3], dl
	
	pop	dx
	ret
  .hdd:
	sub	dl, 0x50
	mov	byte [bx + 3], dl

	pop	dx
	ret

;------HANDLING-ERRORS-----------
if CD = 0
.disk_err_read:
	mov	si, .err_rd
	call	.puts16
; < HALTED IN PREVOUS CALL >
end if

.sig_not_detect:
	mov	si, .sig_nd
	call	.puts16
; < HALTED IN PREVOUS CALL >
;--------------------------------

.puts16:
	cld
	lodsb
	test	al,al
	jz	@f
	cmp	al,0xff
	je	.halt

	xor	bx,bx
	mov	ah,0eh
	int	0x10
	jmp	.puts16
    @@: ret

 .halt:	jmp	$


.sig_nd	db 'signat not detect', 0xff

.info	db '[hd?] efer loader', 0xd, 0xa
if CD
	db 'relocate kernel ...', 0xd, 0xa, 0

times	0x7fe + BOOTOFF - $ db 00

else

	db 'load kernel ...', 0xd, 0xa, 0

.err_rd	db 'err read sector', 0xff

times	0x1fe + BOOTOFF - $ db 00

end if

	db 0x55, 0xaa			; boot sector signature