
; display management
; (c) 2008 kflavour

HEIGHT		= 25
WIDTH		= 80

include 'kerndefs.inc'


;::::::PUT:STRING:::::::::::::::
;void puts(char *(str)esi)

puts:
	cld
	lodsb
	test	al, al
	jz	end_str
	push	esi
	call	putc
	pop	esi
	jmp	puts
  end_str:
	ret

;::::::PUT:CHARACTER::::::::::::
;void putc(char al)

putc:
	test	al, al
	jz	no_char
	cmp	al, BKSP
	je	backspace
	cmp	al, ENTR
	je	newline

; NON-PRINTABLE CHARS
	cmp	al, ESC
	je 	no_char
	cmp	al, TAB
	je 	no_char
	cmp	al, CTRL
	je 	no_char
	cmp	al, ALT
	je 	no_char


	call	outchar
  no_char:
	ret
	
  backspace:
	call	getcurpos
	cmp	[curpos], 0
	je	@f
	dec	[curpos]
	mov	edi, VIDEO
	movzx	eax, word [curpos]
	shl	eax, 1
	add	edi, eax	; edi = VIDEO + (curpos * sizeof(WORD))
	xor	al, al
	stosb
	call	setcurpos
    @@:	ret
  newline:
	call	getcurpos
	mov	bx, [curpos]
	mov	ax, 0
    align_by_width:
	add	ax, WIDTH
	cmp	ax, bx	
	jna	align_by_width
	mov	[curpos], ax
	cmp	ax, HEIGHT * WIDTH - WIDTH	; check bound
	jna	@f
	mov	[curpos], HEIGHT * WIDTH - WIDTH
	call	scrollscr
    @@:	call	setcurpos
	ret



;::::::OUT:CHARACTER::::::::::::
;void outchar(char al)

outchar:
	push	eax
	call	getcurpos
	cmp	[curpos], HEIGHT * WIDTH
	jb	no_scroll
	call	scrollscr
	mov	[curpos], HEIGHT * WIDTH - WIDTH
    no_scroll:
	mov	edi, VIDEO
	movzx	eax, word [curpos]
	shl	eax, 1
	add	edi, eax	; edi = VIDEO + (curpos * sizeof(WORD))
	pop	eax
	stosb
	inc	[curpos]
	call	setcurpos
	ret

;::::::GET:CURSOR:POSITION::::::
getcurpos:
	mov	al, 0xf		; cursor location low
	mov	dx, 0x3d4
	out	dx, al		; index

	mov	dx, 0x3d5
	in	al, dx
	mov	byte [curpos], al	; mov	byte [curpos + 1], al

	mov	al, 0xe		; cursor location high
	mov	dx, 0x3d4
	out	dx, al		; index

	mov	dx, 0x3d5
	in	al, dx
	mov	byte [curpos + 1], al	; mov	byte [curpos], al
	ret

;::::::SET:CURSOR:POSITION::::::
setcurpos:
	mov	dx, 0x3d4
	mov	ah, byte [curpos]	; !
	mov	al, 0xf		; cursor location low
	out	dx, ax	; CRT ctrl

	mov	ah, byte [curpos + 1]	; !
	mov	al, 0xe		; cursor location high
	out	dx, ax	; CRT ctrl
	ret

;::::::SCROLL:SCREEN:::::::::::::
scrollscr:
	mov	esi, VIDEO + (WIDTH * 2)
	mov	edi, VIDEO
	mov	ecx, HEIGHT * (WIDTH * 2) / 4
	cld
	rep	movsd
	mov	ecx, (WIDTH * 2) / 2
	sub	edi, WIDTH * 2
	mov	ah, [attrib]
	mov	al, 0
	rep	stosw
	ret
	
	
	
	
	
;--------DATA--------------------
curpos	dw ?
attrib	db 07	; 00011111b - WHITE ON BLUE