
; stdio in kernel
; (c) kflavour

include 'kerndefs.inc'

ERR	= 0xfade

;:::::::OUT:STRING:::::::::::::::
;void outstr(char *(str)esi, unsigned (pos)ax)

outstr:
	mov	edi, VIDEO
	xor	ecx, ecx
	mov	cl, ah
	and	eax, 0xff
	add	edi, ecx
	mov	cl, 80 * 2
	mul	cl
	add	edi, eax

outchr:
	cld
	lodsb
	test	al, al
	jz	cnt
	stosb
	mov	al, [chr_attrib]
	stosb
	jmp	outchr
cnt:	ret

chr_attrib	db 0x7



;---------------------------------------------
;void	hextostr {
;	ESI lpData,
;	ECX uCounter,
;	EDI lpsDest };
;---------------------------------------------
hextostr:
	cld
	and	eax, 0x0000ffff
nxt_byte:
	lodsb
	mov	ah,al
	shr	al,4

	cmp	al,0Ah
	sbb	al,69h
	das
	cmp	al,'9'
	jbe	@f
	or	al, 0x20
    @@:	cmp	al, '0'
	jne	@f
	test	eax, 0xffff0000
	jnz	store1
	mov	al, ' '
	jmp	store1
    @@:	or	eax, 0x10000
store1:	stosb		;most significant


	mov	al,ah
	and     al,0Fh

	cmp	al,0Ah
	sbb	al,69h
	das
	cmp	al,'9'
	jbe	@f
	or	al, 0x20
    @@:	cmp	al, '0'
	jne	@f
	test	eax, 0xffff0000
	jnz	store0
	cmp	ecx, 1
	je	store0
	mov	al, ' '
	jmp	store0
    @@:	or	eax, 0x10000
store0:	stosb		;least significant
	loop	nxt_byte
	ret

;---------------------------------------------
;	edxtostr {
;	EDX,
;	EDI lpsDest };
;---------------------------------------------
edxtostr:
	push	ebp
	mov	ebp,esp
	sub	esp,4
	bswap	edx
	mov	dword [ebp-4],edx
	mov	ecx,4
	lea	esi,[ebp-4]
	call	hextostr
	leave
	ret

;---------------------------------------------
;	chartonal {
;	AL char
;		 };
;---------------------------------------------
chartonal:
	cmp	al,'0'
	jb	.synerr
	cmp	al,'9'
	ja	@f
	sub	al,30h
	ret
   @@:	cmp	al,'A'
	jb	.synerr
	cmp	al,'F'
	ja	@f
	sub	al,37h
	ret
   @@:	cmp	al,'a'
	jb	.synerr
	cmp	al,'f'
	ja	.synerr
	sub	al,57h
	ret
.synerr:
	mov	esi, snerr
	call	puts
	mov	bx, ERR
	ret

;---------------------------------------------
;	strtohex {
;	ESI lpStr,
;	EDI lpDest
;		 };
;---------------------------------------------
strtohex:
	cld
    @@:	lodsb
	test	al,al
	jz	@f
	cmp	al,'0'
	jb	@b
	call	chartonal
	cmp	bx, ERR
	je	@f
	mov	ah,al
	lodsb
	test	al,al
	jz	.synerr
	call	chartonal
	cmp	bx, ERR
	je	@f	
	shl	ah,4
	or	al,ah
	stosb
	jmp	@b
    @@:	xor	bx, bx
	ret
.synerr:
	mov	esi, snerr
	call	puts
	ret


;---------------------------------------------
;	strtoedx {
;	ESI lpStr
;		 };
;---------------------------------------------
strtoedx:
	enter	4,0
	mov	dword [ebp-4],0
	mov	edi,esi
	mov	ecx,10
	mov	al,0
	cld
	repnz	scasb
	test	cl,cl
	jnz	@f
	leave
	jmp	.synerr
    @@:	dec	edi
	dec	edi
	xchg	esi,edi
	lea	ebx,[ebp-1]
	xchg	ebx,edi
	std
  .trans_next_char:
	lodsb
	call	chartonal
	cmp	bx, ERR
	je	.ret
	lea	ecx,[esi+1]
	cmp	ebx,ecx
	jne	@f
	stosb
	jmp	.ret
    @@:	mov	ah,al
	lodsb
	call	chartonal
	cmp	bx, ERR
	je	.ret
	shl	al,4
	or	al,ah
	stosb
	cmp	ebx,esi
	jbe	.trans_next_char
  .ret:	mov	edx,[ebp-4]
	bswap	edx
	cld
	leave
	xor	bx, bx
	ret
.synerr:
	mov	esi, snerr
	call	puts
	ret


snerr	db 'stdio.inc: syn err in hex str', 0xa, 0